package xyz.matj1.bp.types;

import java.util.concurrent.ConcurrentHashMap;
import java.util.function.BiPredicate;
import java.util.function.BinaryOperator;
import java.util.function.Function;

public class MyMap<K, V> extends ConcurrentHashMap<K, V> {
	public <K2, V2> MyMap<K2, V2> map(Function<? super K, ? extends K2> keyMapper, Function<? super V,  ? extends V2> valueMapper, BinaryOperator<V2> valueMerger) {
		var result = new MyMap<K2, V2>();

		this.entrySet().stream().parallel().forEach(entry -> {
			var mapKey = keyMapper.apply(entry.getKey());
			var mapValue = valueMapper.apply(entry.getValue());

			if (result.containsKey(mapKey)) {
				mapValue = valueMerger.apply(result.get(mapKey), mapValue);
			}

			result.put(mapKey, mapValue);
		});

		return result;
	}

	public <V2> MyMap<K, V2> mapValues(Function<? super V,  ? extends V2> valueMapper) {
		var result = new MyMap<K, V2>();
		this.entrySet().stream().parallel().forEach(
			entry -> result.put(entry.getKey(), valueMapper.apply(entry.getValue()))
		);
		return result;
	}

	public MyMap<K, V> filter(BiPredicate<K, V> predicate) {
		var result = new MyMap<K, V>();

		this.entrySet().stream().parallel().forEach(entry -> {
			if (predicate.test(entry.getKey(), entry.getValue())) {
				result.put(entry.getKey(), entry.getValue());
		}});

		return result;
	}
}
